import logging
import threading
import time
import os

import rclpy
from rclpy.node import Node
from std_msgs.msg import String

import transitions
from transitions.extensions import GraphMachine
from transitions.extensions.states import add_state_features, Timeout

from .skillset import SkillsetInterface

{% for sk in skills|sort %}
class {{ sk.name|action_name }}State(Timeout):
    def __init__(self, name, timeout=0, **kwargs):
        super().__init__(name, on_enter='on_enter_{{ sk.name }}', on_exit='on_exit_{{ sk.name }}',
            timeout=timeout, on_timeout='on_exit_{{ sk.name }}')
        self.__args = kwargs

    @property
    def args(self):
        return self.__args
{% endfor %}

@add_state_features(Timeout)
class {{ skillset.name|data_name }}Machine(GraphMachine):

    def __init__(self, name, namespace='', export=None, publish=False, anonymous=False, **kwargs):
        super().__init__(show_conditions=True, 
            send_event=True, 
            after_state_change='export_machine',
            queued=True,
            **kwargs)

        if anonymous:
            self.__node = rclpy.create_node(f"_{name}_{os.getpid()}_{int(time.time())}", namespace=namespace, use_global_arguments=False)
        else:
            self.__node = rclpy.create_node(name, namespace=namespace)
        self.__skillset = SkillsetInterface(namespace=namespace)
        self.__export = export
        self.__publish = publish
        self.__pub = self.__node.create_publisher(String, name, qos_profile=1)

    def __del__(self):
        del self.__skillset

    def destroy_node(self):
        self.__skillset.destroy_nodes()
        self.__node.destroy_node()

    def export_machine(self, event: transitions.EventData = None):
        if self.__export:
            self.get_graph().draw(self.__export, prog='dot')
        if self.__publish:
            self.__pub.publish(String(data=self.get_graph().string()))

    @property
    def node(self) -> Node:
        return self.__node
    
    {% for sk in skills|sort %}
    # {{ sk.name }}
    def on_enter_{{ sk.name }}(self, event: transitions.EventData):
        self.__node.get_logger().debug("wait {{ sk.name }} manager to be active")
        self.__skillset.skills.{{ sk.name }}.wait_manager(timeout=event.kwargs.get('timeout', 0))
        self.__node.get_logger().debug("starting {{ sk.name }}")
        goal = event.kwargs
        goal.update(event.state.args)
        self.__skillset.skills.{{ sk.name }}.start(**goal)
        t = threading.Thread(target=self.__wait_{{ sk.name }}, args=[event])
        t.start()

    def __wait_{{ sk.name }}(self, event: transitions.EventData):
        self.__node.get_logger().debug("waiting {{ sk.name }}...")
        self.__skillset.skills.{{ sk.name }}.wait()
        result = self.__skillset.skills.{{ sk.name }}.result
        self.__node.get_logger().debug(f"got result {result}")
        try:
            return self.trigger(result, **event.kwargs)
        except:
            pass
        try:
            return self.trigger('ERROR', **event.kwargs)
        except:
            pass

    def on_exit_{{ sk.name }}(self, event: transitions.EventData):
        if self.__skillset.skills.{{ sk.name }}.running:
            self.__node.get_logger().debug("[{{ sk.name }} on_exit] interrupt {{ sk.name }}")
            self.__skillset.skills.{{ sk.name }}.interrupt()
            self.__node.get_logger().debug("[{{ sk.name }} on_exit] wait interruption of {{ sk.name }}")
    {% endfor %}

    {% for r in resources|sort %}
    # {{ r.name }}
    {% for s in r.statemachine.states|sort %}
    def is_{{ r.name }}_{{ s }}(self, event: transitions.EventData):
        return self.__skillset.resources.{{ r.name }}.get() == '{{ s }}'
    {% endfor %}
    {% endfor %}
